:
#
# version 3.0 Sep 25 11:21:02 PDT 1998

umask 022

# This tool suite was written by and is copyrighted by Brad Powell, Matt 
# Archibald, and Dan Farmer 1992, 1993, 1994, 1995, 1996, 1997, 1998 with input 
# from Casper Dik, and Alec Muffett.
#
# The copyright holder disclaims all responsibility or liability with  
# respect to its usage or its effect upon hardware or computer 
# systems, and maintains copyright as set out in the "LICENSE"  
# document which accompanies distribution. 
  
# Some of the ideas and code for the sunos 4.1.X version of titan was
# modified from code from a program secure_sun author David Safford

TITANHOME=`pwd`
PATH=/usr/ucb:/bin:/usr/bin:/sbin:$TITANHOME/lib
MYNAME=`basename $0`
# did things work out or not?
action=`sanity_check $MYNAME $1`
if test $? -ne 0 ; then
        exit 1
        fi

. misc_functions.sh
 
Intro() {

cat << EOF_INTRO

	Check /etc/utmp not world writeable

 NOTE: the following fix will interefere with normal use of sunview.
       Apply this fix only on a server, or machines not running sunview
       or give all valid users group write access to /etc/utmp.


EOF_INTRO

}

#
#    check_/etc/utmp - if world writeable, fix
#

Check() {
t_echo 2 Testing that /etc/utmp not writeable by world 
if  ls -l /etc/utmp |grep -s "^........w"
then
	t_echo 0  "     utmp is writeable: FAILS CHECK"
else
	t_echo 2  "     utmp is not writable: PASSES CHECK"
fi
}

Fix() {
if  ls -l /etc/utmp |grep -s "^........w"
 then
	t_echo 0  "     Changing /etc/utmp to be non-world writable"
	chmod o-w /etc/utmp
 else
	t_echo 2 "    utmp is not writable: PASSES CHECK" 
fi
}

action=$1
case $action in
 -[Ff]*)
Fix
;;
 -[Vv]*)
Check
;;
 -[Ii]*)
Intro
;;
 
*)
        t_echo 1 "        ERROR:Invalid arg $action"
        t_echo 1 "        ERROR:Usage $MYNAME -[ivf] (I)ntro/(V)erify/(F)ix"
 
        t_echo 1 " "
;;
esac

